'To construct a from-to table fron XY coordinate pairs and a value.
'Tobler, Waldo 3-3-05
'MS QuickBasic 4.5
CLS
CLOSE
OPTION BASE 1
COLOR 14
PRINT
PRINT "   This program produces node numbers from XY pairs and values."
PRINT "   The inputs is X1,Y1, then X2,Y2, then the value, all on one line."
PRINT "   The first coordinate set, X1, Y1 identifies the origin."
PRINT "   The second coordinate set, X2, Y2 identifies the destination."
PRINT "   The value is the quantity of traffic moving from X1, Y1 to X2, Y2."
PRINT "   The program results in a from-node number and a to-node number"
PRINT "   with the quantity moving between them, all printe on one line"
PRINT "   and a node by node array with values entered."
PRINT "   Location to same location cases go to the diagonal."
PRINT "   Only commas or blanks are allowed as delimiters."
PRINT

COLOR 15

PRINT
INPUT "   Enter the name of the file containing the data "; InFile$
'InFile$ = "C:\x1y1x2y2.txt"
INPUT "   Next enter the name of the file for the results "; OutFile$
'OutFile$ = "C:\XY2Node.txt"
INPUT "   Do you wish extensive printer output as well as the from-to table N/Y"; Ink$
'Assumes that a printer is attached and turned on.
Ink$ = UCASE$(Ink$)
IF UCASE$(Ink$) <> "Y" THEN
  Ink = 0
  PRINT "   Printer output will not be provided."
ELSE
  Ink = 1
  PRINT "   Printer output will be provided if a printer is attached and turned on."
END IF

OPEN "I", #1, InFile$
'First pass to get an estimae of the number of nodes.

IF Ink <> 0 THEN
  LPRINT "RESULTS OF THE CONVERSION OF XY COORDINATES TO NODES AND A FROM-TO TABLE."
  LPRINT "Run of "; DATE$; " begun at "; TIME$
  LPRINT
 'LPRINT "Echoing input values"
END IF
DO WHILE NOT EOF(1)
  INPUT #1, X1, Y1, X2, Y2, V
  count = count + 1
 'IF Ink <> 0 THEN LPRINT count; X1; Y1; X2; Y2; V
LOOP
CLOSE 1
Nodes = 2 * count + 2  'This is the maximum assuming all are unique.

OPEN "O", #2, OutFile$
PRINT #2, "Results from the XY to node program."

DIM N%(Nodes), Nx(Nodes), Ny(Nodes)
'Each entry is (1) assigned a node number, and (2) its X coordinate,
'and (3) its Y coordinate.
'On the first pass just assign each X,Y pair a unique node number.
'On the second pass associate the value with the node pair.
'Ignore the value on the first pass

'Second pass to identify the nodes
OPEN "I", #1, InFile$
K = 1

DO WHILE NOT EOF(1)
  INPUT #1, X1, Y1, X2, Y2, Value

 'If this is the first pair give Node 1 the value of X1, Y1
 'and give Node 2 the value of X2, Y2.
 'For the rest of the list the coordinates must be compared to the
 'already assigned node numbers.
 
  IF K = 1 THEN
    K2 = 1
   'Set node number one
    N%(1) = K
    Nx(1) = X1
    Ny(1) = Y1
   'Look at the second location X,Y pair
    IF Nx(K) <> X2 AND Ny(K) <> Y2 THEN
      K = K + 1
      N%(K) = K
      Nx(K) = X2
      Ny(K) = Y2
    ELSE
     'This is the same point
     'What to do?
     'PRINT #2, "The first node is sending stuff to itself."
     'PRINT #2, "It will not be counted twice as a node."
     'PRINT #2, "But check the value for this item on the table diagonal."
      Diag = Diag + 1
      GOTO Itself
    END IF
  ELSE
   'Not the first entry
    K2 = K2 + 1
    FOR I = 1 TO K
     'Has this point previously been found?
     'Look at the first coordinate pair
     'Can an earlier node number be used?
      IF X1 = Nx(I) AND Y1 = Ny(I) THEN GOTO Second
    NEXT I
    'It's a new point
     K = K + 1
     N%(K) = K
     Nx(K) = X1
     Ny(K) = Y1
Second:
    'Now look at the second location (set of coordinates)
     IF X2 = X1 AND Y2 = Y1 THEN
      'This is the same point
      'PRINT #2, "CAUTION:"
      'PRINT #2, "The node in entry line"; K2; "is sending stuff to itself."
       Diag = Diag + 1
       IF Diag >= 1 THEN GOTO GotIt
      'PRINT #2, "It will not be counted as a new node, but the value it"
      'PRINT #2, "carries will be on the diagonal of the resulting array"
      'PRINT #2, "and counts as a table entry. Row and column sums are affected."
      'PRINT #2,
       GOTO GotIt
     END IF
     FOR I = 1 TO K
      'See if we can use the earlier node number
       IF X2 = Nx(I) AND Y2 = Ny(I) THEN GOTO GotIt
     NEXT I
    'It's a new coordinate pair
     K = K + 1
     N%(K) = K
     Nx(K) = X2
     Ny(K) = Y2
GotIt:
  END IF
Itself:

LOOP

PRINT
PRINT "   The total number of unique points is:"; K
PRINT "   and these came from"; K2; "lines that were read from"
PRINT "   the input file: "; InFile$
PRINT #2,
PRINT #2, "   The total number of unique points is:"; K
PRINT #2, "   and these came from"; K2; "lines that were read from"
PRINT #2, "   the input file: "; InFile$

CLOSE 1
PRINT
INPUT "   Press enter to contine ", z$
'There are K uniquely identified coordinate pairs"

IF Ink <> 0 THEN
  LPRINT
  LPRINT "The"; K; "nodes and their coordinates are:"
END IF
PRINT #2,
PRINT #2, "The"; K; "Nodes and their coordinates are:"
FOR I = 1 TO K
  PRINT #2, N%(I); Nx(I); Ny(I)
  IF Ink <> 0 THEN LPRINT N%(I); Nx(I); Ny(I)
NEXT I
PRINT
PRINT "  "; K; "unique nodes were found."
PRINT

'Third pass to get the paired nodes and traffic value.
'Start the next procedure:
Fmt$ = "######"
K2 = 0
IF Ink <> 0 THEN
  LPRINT
  LPRINT "The array entries are:"
  LPRINT "(Row, Columns, value)"
END IF

OPEN "I", #1, InFile$
DIM T%(K, K)
K2 = 0
DO WHILE NOT EOF(1)
  INPUT #1, X1, Y1, X2, Y2, Value
  'Compare the input coordinates with the node coordinates
   FOR L = 1 TO K
     IF X1 = Nx(L) AND Y1 = Ny(L) THEN
       I = L
       GOTO GotRow
     END IF
   NEXT L
GotRow:
   FOR M = 1 TO K
     IF X2 = Nx(M) AND Y2 = Ny(M) THEN
       J = M
       GOTO GotCol
     END IF
   NEXT M
GotCol:
  'Put the values into the array
   T%(I, J) = Value
   K2 = K2 + 1
  'Make a printed record
   IF Diag > 0 AND I = J THEN
     IF Ink <> 0 THEN LPRINT N%(I); N%(J); Value; ".....Diagonal"
   ELSE
     IF Ink <> 0 THEN LPRINT N%(I); N%(J); Value
   END IF

LOOP

IF Ink <> 0 THEN
  LPRINT "There are"; K2; "non-zero entries in the array,"
  IF Diag > 1 THEN
    LPRINT "including"; Diag; "diagonal values."
  ELSE
    LPRINT "including a single diagonal value."
  END IF
END IF

PRINT #2,
PRINT #2, "Computation completed at "; TIME$; " on "; DATE$
PRINT #2, "This is file "; OutFile$
PRINT #2, "The array is"; K; "by"; K; "in size with"; K2
PRINT #2, "non-zero entries from"; K * K - K; "possibilities,"
IF Diag > 0 THEN
  IF Diag > 1 THEN
    PRINT #2, "plus"; Diag; "diagonal values."
  ELSE
    PRINT #2, "with a single value on the diagonal."
  END IF
END IF
PRINT #2, "The data came from "; InFile$
PRINT #2, "Program XY_2Node provided by W. Tobler"
PRINT #2,
DIM RowSum(K + 1), ColSum(K + 1)
'Now write out the result
FOR L = 1 TO K
  FOR M = 1 TO K
    ColSum(M) = ColSum(M) + T%(L, M)
    RowSum(L) = RowSum(L) + T%(L, M)
    PRINT #2, USING Fmt$; T%(L, M);
  NEXT M
  PRINT #2,
NEXT L
PRINT #2,
PRINT "   The computation was completed at "; TIME$; " on "; DATE$
PRINT "   The results were sent to "; OutFile$
IF Ink <> 0 THEN LPRINT
IF Ink = 0 THEN GOTO SkipPrnt
LPRINT "Row and column sums, to check for zero rows or columns."
IF Diag > 0 THEN LPRINT "Also check the diagonal for entries."
FOR I = 1 TO K
  LPRINT RowSum(I); ColSum(I)
  SumRow = SumRow + RowSum(I)
  SumCol = SumCol + ColSum(I)
NEXT I
LPRINT "Row and column totals are:"
LPRINT SumRow; SumCol
LPRINT
LPRINT "The computation was completed at "; TIME$; " on "; DATE$
LPRINT "The data came from "; InFile$
LPRINT "The"; K; "by"; K; "from-to table went to "; OutFile$
SkipPrnt:
CLOSE
INPUT "   Press enter to continue ", z$
END

