'To convert coordinate list & polygon IDs to Flow Mapper input
'W. Tobler 4-3-05
CLS
OPTION BASE 1
CLOSE
Xmax = -1000000!
Ymax = Xmax
Xmin = -Xmax
Ymin = Xmin

'Change the following values as needed

InFile1$ = "C:\Ausie1.dat"
InFile2$ = "C:\Ausie2.dat"
OutFile1$ = "C:\NewBnd.Ply"
OutFile2$ = "C:\NewCnt.Pts"

OPEN "I", #1, InFile1$
OPEN "I", #2, InFile2$
OPEN "O", #3, OutFile1$
OPEN "O", #4, OutFile2$

N = 233    'The number of coordinates  Change these values as needed
A = 7      'The number of polygonal regions
Size = 69  'The maximum number of nodes in a polygon + 1

DIM X(N), Y(N), P(Size), Px(Size), Py(Size), CenX(A), CenY(A)
FOR I = 1 TO N
  INPUT #1, Y(I), X(I)   'Reversed for Australia
  IF X(I) > Xmax THEN Xmax = X(I)
  IF Y(I) > Ymax THEN Ymax = Y(I)
  IF X(I) < Xmin THEN Xmin = X(I)
  IF Y(I) < Ymin THEN Ymin = Y(I)
NEXT I
PRINT "Coordinates have been read."
PRINT "Xmin= "; Xmin; "Xmax= "; Xmax
PRINT "Ymin= "; Ymin; "Ymax= "; Ymax

'For the input the polygon number and number of nodes for that polygon
'are now read. Then, on the next line, the polygon IDs are read.
'Each item must be separated by blanks.

FOR J = 1 TO A
  'INPUT #2, Poly, Nr   'Iff polygons numbered
  INPUT #2, Nr
  'Nr1 = Nr + 1   'changed since the first = the last point
  Nr1 = Nr
  FOR K = 1 TO Nr
    INPUT #2, P(K)
    Px(K) = X(P(K))
    Py(K) = Y(P(K))
  NEXT K
    'Px(Nr1) = Px(1)      'Assumes that the last node <> the first node
    'Py(Nr1) = Py(1)

 'Now compute center of gravity, assuming plane (rectangular, Euclidean)
 'coordinates.
  B1 = 0!
  B2 = 0!
  FOR K = 1 TO Nr
    M = K + 1
    IF M > Nr THEN M = 1
    B1 = (Py(M) - Py(K)) * (Px(K) ^ 2 + Px(K) * Px(M) + Px(M) ^ 2) + B1
    B2 = Px(K) * Py(M) - Px(M) * Py(K) + B2
  NEXT K
  IF B2 <> 0 THEN
    CenX(J) = B1 / (3! * B2)
  END IF
  B1 = 0!
  B2 = 0
  FOR K = 1 TO Nr
    M = K + 1
    IF M > Nr THEN M = 1
    B1 = (Px(M) - Px(K)) * (Py(K) ^ 2 + Py(K) * Py(M) + Py(M) ^ 2) + B1
    B2 = Py(K) * Px(M) - Py(M) * Px(K) + B2
  NEXT K
  IF B2 <> 0 THEN
    CenY(J) = B1 / (3! * B2)
  END IF
 'Center of gravity computed.

 'Output the coordinates
  PRINT #3, "-9"
  FOR I = 1 TO Nr1
    PRINT #3, Px(I); Py(I)     '-1 is for upside down Australia
  NEXT I
NEXT J
PRINT #3,
PRINT "Coordinate string printed in format for Flow Mapper"
PRINT "in file "; OutFile1$
'Print the centers of gravity
FOR K = 1 TO A
  PRINT #4, CenX(K); CenY(K)   '-1 is for upside down australia
NEXT K
PRINT "Centers of gravity printed in file "; OutFile2$

PRINT
PRINT "Finished at "; TIME$; " on "; DATE$
PRINT "Results have been sent to both "; OutFile1$; " and "; OutFile2$
PRINT "The data came from "; InFile1$; " and "; InFile2$
                                                                   
CLOSE
END

