'To read node to node and a value and create a from-to table.
'Tobler, Waldo   3-3-05
CLS
CLOSE
OPTION BASE 1
Fmt$ = "######"
MaxNode% = -10000
MinNode% = 10000
COLOR 14
PRINT
PRINT "    This program reads two node numbers and a value."
PRINT "    The fist node number is a source (from) node."
PRINT "    The second node number is the destination (to) node."
PRINT "    As input the program expects"
PRINT "    the from-node, then the to-node, then a value, all on one line."
PRINT "    The nodes can be in any order, but always from-then-to."
PRINT "    Several moves between the same from-to node pair will be cumulated."
PRINT "    The program will then produce a square from-to table."
PRINT "    This table will be node by node in size, with the values entered."
PRINT "    This is the format used for entry into the Flow Mapper program."
PRINT "    Only comma delimited and blanks are allows. Tab delimited files do not work."
PRINT
COLOR 15
INPUT " Enter the number of nodes  ", Nodes%
PRINT
INPUT " Enter the input file name  ", InFile$
'InFile$ = "C:\nod_2Nod.txt"
PRINT " Your data are coming from "; InFile$
PRINT
INPUT " Enter the output file name ", OutFile$
'OutFile$ = "C:\nodes.txt"
PRINT " Your results are being sent to :"; OutFile$
PRINT
INPUT " Do you wish extensive printed output  N/Y "; Paper$
Paper$ = UCASE$(Paper$)
IF Paper$ <> "Y" THEN Paper$ = "N"
IF Paper$ = "Y" THEN PRINT " Results will be printed if a printer is attached and turned on."
OPEN "I", #1, InFile$
OPEN "O", #2, OutFile$
PRINT #2, "These results are from converting a list of O-D nodes"
PRINT #2, "to a square array for use in Tobler's Flow Mapper program."
PRINT #2,
PRINT
IF Paper$ = "Y" THEN
  LPRINT "Beginning output from the NdNr2Sqr program."
  LPRINT "Started at "; TIME$; " on "; DATE$
  LPRINT "The data are from "; InFile$
  LPRINT "The results have been sent to "; OutFile$
  LPRINT "The number of nodes specified  is "; Nodes%
  LPRINT
END IF

DIM T%(Nodes%, Nodes%), RowSum(Nodes%), ColSum(Nodes%)

DO WHILE NOT EOF(1)
  INPUT #1, FromNode%, ToNode%, Value
  IF FromNode% < 1 OR ToNode% < 1 THEN
    IF Paper$ = "Y" THEN
      LPRINT "Zero or nagative nodes are not allowed"
      LPRINT "Check your input file."
      Bad = Bad + 1
    END IF
    GOTO BadValue
  END IF
  IF FromNode% > Nodes% THEN
    IF Paper$ = "Y" THEN
      LPRINT "The from-node "; FromNode%; " is too large"
      LPRINT "This entry will be ignored."
      Bad = Bad + 1
    END IF
    GOTO BadValue
  END IF
  IF ToNode% > Nodes% THEN
    IF Paper$ = "Y" THEN
      LPRINT "The to-node "; ToNode%; " is too large"
      LPRINT "This enty will be ignored."
      Bad = Bad + 1
    END IF
    GOTO BadValue
  END IF
  IF Value < 0 THEN
    PRINT #2, "The value from "; FromNode%; " to"; ToNode%; "is negative."
    PRINT #2, "This will be allowed but may be an error. You should check."
    N% = N% + 1
  END IF
 'Get Largest & snallest node numbers.
 'This to set the size of the resulting array.
  IF FromNode% > MaxNode% THEN MaxNode% = FromNode%
  IF ToNode% > MaxNode% THEN MaxNode% = ToNode%
  IF FromNode% < MinNode% THEN MinNode% = FromNode%
  IF ToNode% < MinNode% THEN MinNode% = ToNode%
 
  IF T%(FromNode%, ToNode%) <> 0 THEN
    T%(FromNode%, ToNode%) = T%(FromNode%, ToNode%) + Value
   'More than one entry for this pair
    E% = E% + 1
  ELSE
    T%(FromNode%, ToNode%) = Value
  END IF

  RowSum(FromNode%) = RowSum(FromNode%) + Value
  ColSum(ToNode%) = ColSum(ToNode%) + Value
  IF FromNode% = ToNode% THEN D% = D% + 1
  K = K + 1

BadValue:
LOOP
IF Paper$ = "Y" AND Bad > 0 THEN LPRINT Bad; "bad values occured. Examine your input values."
Dif% = MaxNode% - MinNode% + 1
COLOR 7
PRINT
PRINT "  All values have been read."
PRINT
IF E% > 0 AND Paper$ = "Y" THEN
  IF Paper$ = "Y" THEN LPRINT "There were"; E%; " duplicate from-to node pairs."
  IF Paper$ = "Y" THEN LPRINT "The values for these items has been cumulated. "
  IF Paper$ = "Y" THEN LPRINT "These duplicate node to node entries are not counted in the number of table entries."
END IF
PRINT "  There are"; K - E%; "entries in the"; Dif%; "by"; Dif%; "table."
PRINT "  out of a possible"; Dif% * Dif% - Dif%; "(omitting the diagonal)."
PRINT
PRINT #2, "The row sums are:"
FOR I = 1 TO Nodes%
  PRINT #2, RowSum(I)
  SumRow = SumRow + RowSum(I)
NEXT I
PRINT #2, "The column sums are:"
FOR J = 1 TO Nodes%
  PRINT #2, ColSum(J)
  Sumcol = Sumcol + ColSum(J)
NEXT J
  PRINT #2, "Row, Column totals"
  PRINT #2, SumRow; Sumcol
IF N% = 0 THEN
  IF Paper$ = "Y" THEN LPRINT "No negative values occured."
ELSE
  IF Paper$ = "Y" THEN LPRINT "There were"; N%; "negative values in input."
END IF
IF D% = 0 THEN
  IF Paper$ = "Y" THEN LPRINT "There are no entries on the diagonal."
ELSE
  IF D% = 1 THEN
    IF Paper$ = "Y" THEN LPRINT "There is one diagonal entry."
  ELSE
    IF Paper$ = "Y" THEN LPRINT "There are"; D%; "diagonal entries."
  END IF
END IF

IF Paper$ = "Y" THEN
  LPRINT "The lower node number is"; MinNode%
  LPRINT "The upper node number is"; MaxNode%
  LPRINT
END IF

PRINT #2,
PRINT #2, "Here is the"; Dif%; "by"; Dif%; "Table:"
PRINT #2,
FOR I% = MinNode% TO MaxNode%
  FOR J% = MinNode% TO MaxNode%
    PRINT #2, USING Fmt$; T%(I%, J%);
  NEXT J%
  PRINT #2,
NEXT I%
PRINT "  The resulting"; Dif%; "by"; Dif%; "table has been sent to "; OutFile$
PRINT "  The data came from "; InFile$
PRINT "  This computation finished at "; TIME$; " on "; DATE$
PRINT #2,
PRINT #2, "The input data for this"; Dif%; "by"; Dif%; "table came from "; InFile$
PRINT #2, "This is file "; OutFile$
PRINT #2, "This computation finished at "; TIME$; " on "; DATE$
IF Paper$ = "Y" THEN PRINT #2, "There is paper output on the printer."
PRINT #2, "The program was produced by W. Tobler for use with the"
PRINT #2, "Flow Mapper program on 3-3-05"
CLOSE
INPUT "  Press enter to quit", Z$
END

