DECLARE SUB Face (Style$, X!, Y!, Size!)
DEFINT I-K, N
CLS
PRINT "            Program to Draw + or - Symbols on Map"
PRINT "            -------------------------------------"
PRINT "                      By Waldo Tobler"
PRINT ""
INPUT "  Did you install a screen saver for graphics Y/N "; S$
IF UCASE$(S$) <> "Y" THEN
  INPUT "  Do you wish to install a screen saver Y/N "; SS$
    IF UCASE$(SS$) <> "N" THEN
    PRINT
    PRINT "  The program will stop in order for you to load a screen saver."
    PRINT "  When done you can restart the program."
    GOTO Done
  END IF
END IF

INPUT "  Do you wish +/- (S) or Faces (F) "; Style$
Style$ = UCASE$(Style$)

Vmax = -1E+09
Xmax = Vmax
Ymax = Vmax
Xmin = -Vmax
Ymin = Xmin
New = 0
PRINT
INPUT "  Enter the number of cases:  ", N
DIM V(N), X(N), Y(N)
PRINT
INPUT "  Enter size of symbols desired (1 - 5), 3 recommended:  "; F
IF F = 0 THEN F = 2
IF F < 0 THEN F = 1
IF F > 5 THEN F = 5
Fineness = F ^ 1.5
DoOver1:
PRINT
INPUT "  Enter the name of the data file:  "; DataIn$
DataIn$ = "C:\china\cmig.dat"
FOR I = 1 TO LEN(DataIn$)
  A$ = MID$(DataIn$, I, 1)
  IF A$ = ";" THEN
    BEEP
    BEEP
    GOTO DoOver1
  END IF
NEXT I
OPEN "I", 2, DataIn$
DoOver2:
PRINT
INPUT "  Enter the name of the coordinate file:  "; XYin$
FOR I = 1 TO LEN(XYin$)
  A$ = MID$(XYin$, I, 1)
  IF A$ = ";" THEN
    BEEP
    BEEP
    GOTO DoOver2
  END IF
NEXT I
OPEN "I", #1, XYin$
PRINT
INPUT "  Do you have a boundary file Y/N  "; Bdy$
IF UCASE$(Bdy$) = "Y" THEN
DoOver3:
  PRINT
  INPUT "  Enter name of the boundary coordinate file:   "; Bdyin$
  FOR I = 1 TO LEN(Bdyin$)
    A$ = MID$(Bdyin$, I, 1)
    IF A$ = ";" THEN
      BEEP
      BEEP
      GOTO DoOver3
    END IF
  NEXT I
  OPEN "I", #3, Bdyin$
END IF
Retry:
CLS
PRINT
PRINT "    What is the form of the data?"
PRINT
PRINT " 1. Already computed Plus/Minus values"
PRINT " 2. Both in and out values; subtract to get Plus/Minus values"
PRINT " 3. Full interaction table; compute Plus/Minus values"
PRINT
INPUT "    Enter one of the above numbers:  ", Entry%
IF Entry% < 1 THEN GOTO Retry
IF Entry% > 3 THEN GOTO Retry
PRINT

'Read the data
ON Entry% GOTO CASE1, CASE2, CASE3

CASE1:
 ' Already computed net values
 FOR I = 1 TO N
   INPUT #2, V(I)
   IF ABS(V(I)) > Vmax THEN Vmax = ABS(V(I))
 NEXT I
 GOTO CaseEnd

CASE2:
 ' Get difference for net values
 PRINT "    Computing";
   FOR I = 1 TO N
     INPUT #2, V1, V2
     V(I) = V1 - V2
     IF ABS(V(I)) > Vmax THEN Vmax = ABS(V(I))
     PRINT ".";
    'PRINT I, v1; v2; V(I); Vmax
    'INPUT x$
   NEXT I
   GOTO CaseEnd

CASE3:
 ' Get net values by summing rows and columns of complete table.
 ' Assumes rows denote from places; column places are destinations.
 ' The marginals will be written to a file
   OPEN "O", #4, "MIGRTABL.out"
 ' Assumes drive is a ram disk.
   DIM R(N), C(N)
   PRINT "    Computing";
   FOR I = 1 TO N
     FOR J = 1 TO N
       INPUT #2, T
       C(J) = C(J) + T
       R(I) = R(I) + T
     NEXT J
     PRINT ".";
   NEXT I
   FOR J = 1 TO N
     V(J) = C(J) - R(J)
     PRINT #4, V(J); C(J); R(J); J
     IF ABS(V(J)) > Vmax THEN Vmax = ABS(V(J))
   NEXT J

CaseEnd:

PRINT
' Read the coordinates
FOR K = 1 TO N
  INPUT #1, X(K), Y(K)
  Y(K) = Y(K) * 4 / 3
  IF X(K) > Xmax THEN Xmax = X(K)
  IF Y(K) > Ymax THEN Ymax = Y(K)
  IF X(K) < Xmin THEN Xmin = X(K)
  IF Y(K) < Ymin THEN Ymin = Y(K)
NEXT K
IF K - 1 <> N THEN
  PRINT "Error, number of data values and coordinates do not agree."
  PRINT "Will plot the lesser of the two."
  IF K < N THEN N = K
END IF
IF UCASE$(Bdy$) <> "Y" THEN GOTO NoBdy
' Read the boundary
DIM Xb(500), Yb(500)
Ib = 0
DO WHILE NOT EOF(3)
  Ib = Ib + 1
  INPUT #3, Xb(Ib), Yb(Ib)
  Yb(Ib) = Yb(Ib) * 4 / 3
  IF Xb(Ib) > Xmax THEN Xmax = Xb(Ib)
  IF Yb(Ib) > Ymax THEN Ymax = Yb(Ib)
  IF Xb(Ib) < Xmin THEN Xmin = Xb(Ib)
  IF Yb(Ib) < Ymin THEN Ymin = Yb(Ib)
LOOP
NoBdy:
Dx = Xmax - Xmin
Dy = Ymax - Ymin
Range = Dy
IF Dx > Dy THEN Range = Dx
Xmax = Xmax + .1 * Range
Ymin = Ymin - .1 * Range
Xmin = Xmax - 1.2 * Range
Ymax = Ymin + 1.2 * Range
CLS
' Get ready to plot
SCREEN 9
WINDOW (Xmin, Ymin)-(Xmax, Ymax)
'PRINT "Vmax="; Vmax; "Scal="; Scale; "Fine="; Fineness
Rescale:
IF UCASE$(Bdy$) <> "N" THEN
  ' Plot boundary
  PSET (Xb(1), Yb(1))
  FOR I = 2 TO Ib
    LINE -(Xb(I), Yb(I)), 14
  NEXT I
END IF
IF UCASE$(Bdy$) <> "Y" THEN
  ' Do a border if there is no boundary
  IF New = 1 THEN GOTO Noshift
  Xmin = Xmin + .05 * Range
  Xmax = Xmin + 1.1 * Range
  Ymin = Ymin + .05 * Range
  Ymax = Ymin + 1.1 * Range
Noshift:
  PSET (Xmin, Ymin)
  LINE -(Xmax, Ymin), 14
  LINE -(Xmax, Ymax), 14
  LINE -(Xmin, Ymax), 14
  LINE -(Xmin, Ymin), 14
END IF

Scale = Fineness * Range / (100 * SQR(Vmax))
' Plot symbols
FOR I = 1 TO N
 'PRINT I, V(I);
  W = Scale * SQR(ABS(V(I))) * SGN(V(I))
 'PRINT W
 'INPUT x$
  Dx = ABS(W) / 2
  U1 = X(I) - Dx
  U2 = X(I) + Dx
  V1 = Y(I)
  IF Style$ = "F" THEN
    Radius = Dx
    Symbol$ = "H"
    IF W <= 0 THEN Symbol$ = "S"
    CALL Face(Symbol$, X(I), Y(I), Radius)
    GOTO Skip
  END IF
  IF W <> 0! THEN
  ' Minus sign
    PSET (U1, V1)
    IF W < 0 THEN
      LINE -(U2, V1), 1
    ELSE
      LINE -(U2, V1), 4
    END IF
  ' Plus sign
    IF W > 0 THEN
      U1 = X(I)
      V1 = Y(I) - Dx * 4 / 3
      V2 = Y(I) + Dx * 4 / 3
      PSET (U1, V1)
      LINE -(U1, V2), 4
    END IF
  ELSE
  ' Zero value
    PSET (X(I), Y(I))
  END IF
Skip:
NEXT I

'COLOR 8
Now$ = MID$(TIME$, 1, 5)
PRINT Now$; " "; DATE$; "  Using "; UCASE$(DataIn$);
INPUT "  Replot changing scale Y/N "; X$
COLOR 15
IF UCASE$(X$) = "Y" THEN
  INPUT "Enter new value for fineness (1 - 5) ", F
  Fineness = F ^ 1.5
  IF F < 1 OR F > 5 THEN GOTO Done
  CLS
  New = 1
  GOTO Rescale
END IF
Done:
PRINT
CLS
PRINT "                 THANK WALDO TOBLER FOR THIS PROGRAM"
INPUT "                                                                        ", X$
END

DEFSNG I-K, N
SUB Face (Style$, X, Y, Size)
'To draw a face of Size, Happy or Sad, at X,Y, in color
SCREEN 9
'Y = Y * 3 / 4
eye = .04 * Size
Mouth = .75 * Size
PSET (X, Y)

SELECT CASE Style$

CASE "H"         'Happy face
  CIRCLE (X, Y), Size, 4
  PAINT (X, Y), 4
  CIRCLE (X, Y), Size, 14
 'Do eyes
  CIRCLE (X - .08 * X, Y - .2 * Y), eye, 14  'Right
  CIRCLE (X + .08 * X, Y - .2 * Y), eye, 14  'Left
  CIRCLE (X, Y - Size / 4), Mouth, 14, 3.93, 5.5

CASE "S"         'Sad face
  CIRCLE (X, Y), Size, 14
  PAINT (X, Y), 1, 14
 'Do eyes
  CIRCLE (X - .08 * X, Y - .2 * Y), eye, 14  'Right
  CIRCLE (X + .08 * X, Y - .2 * Y), eye, 14  'Left
  Y = Y + .75 * Size
  CIRCLE (X, Y), Mouth, 14, .79, 2.36
END SELECT
END SUB

