'POTENTIAL FIELD FROM DATA GIVEN BY POLYGONS CONVERTED
'TO A LATTICE USING THE POLYGRID PROGRAM.
'COMPUTED AS THE SOLUTION TO THE POISSON EQUATION
'WITH BOUNDARY CONDITION DZ/DN=0.
'SUMMER 1978, REVISED, CONVERTED TO BASIC, SPRING 1994. Rev 6/8/98
'Email: tobler@geog.ucsb.edu
DEFSNG A-H, O-Z: DEFINT I-N
DECLARE SUB Plane (Rows%, Cols%, Z!(), A!, B!, C!)
DECLARE SUB Plotsize (Scrn%, Xmin!, Xmax!, Ymin!, Ymax!)
DECLARE SUB SetUpTri (Rows%, Cols%, Scrn%, Z!(), H!)
DECLARE SUB DrawGrid (Rows%, Cols%, Scrn%, Xmax!, Xmin!, Ymax!, Ymin!)
DECLARE SUB IsoPlot (Rows%, Cols%, Scrn%, Nits%, Z!(), Xmin!, Xmax!, Ymin!, Ymax!, Zmin!, Zmax!, C!, Titl$)
DECLARE SUB Poisson (Nrow, Ncol, Nsmuth, Nplus, Nits%)
DECLARE SUB Pm (Nplus%, Nr%, Nc%, Xmin!, Xmax!, Ymin!, Ymax!)
DECLARE SUB NicePrint (Nrows, Ncols, Unit%, Z!())
DECLARE SUB DrawSurface (Rows%, Cols%, Scrn%, Z!(), Titl$, Nits%)
DECLARE SUB Queens (S!, SK!, Nplus, Jminus, Jplus1, Iminus, Iplus1)
DECLARE SUB Order (X1!, X2!, X3!, Y1!, Y2!, Y3!, F1!, F2!, F3!)
DECLARE SUB TriCon (X1!, X2!, X3!, Y1!, Y2!, Y3!, F1!, F2!, F3!, H!)
DECLARE FUNCTION Xint! (X1!, X2!, F1!, F2!, Fi!)
DECLARE FUNCTION Max! (A!, B!)
DECLARE FUNCTION Min! (A!, B!)
      COMMON Narea(), RegValu(), ID(), Source(), Z()
      OPTION BASE 1
      CLS
      CLOSE
      Fmt1$ = "#####"
      Fmt2$ = "###.####^^^^"
      Fmt3$ = ".######^^^^"
      RegMin = 1E+30
      RegMax = -RegMin
      Nits% = 0
COLOR 10
PRINT
PRINT "     PROGRAM TO SOLVE POISSON'S EQUATION FOR A RECTANGULAR REGION"
PRINT "                  WITH Dz/Dn = 0 ON THE BOUNDARY."
PRINT
NewRegion:
COLOR 7
INPUT " Enter the number of regions:  ", Nregs
IF Nregs < 2 THEN
  COLOR 10
  PRINT " That won't work. Try again"
  GOTO NewRegion
END IF
Nplus = Nregs + 1
INPUT " Enter the name of the file containing the Source/Sink values ", InValFle$
OPEN "I", #1, InValFle$
INPUT " Enter the name of the file containing the array of ID numbers ", IdFileNam$
OPEN "I", #2, IdFileNam$
PRINT " Enter the size of this array "
INPUT " Number of Rows:  ", Nrow
IF Nrow < 3 THEN
  COLOR 10
  PRINT " That is not a valid size. Your array is too small!"
  PRINT " Program stopped."
  COLOR 7
  GOTO TheEnd
END IF
INPUT " Number of Columns:  ", Ncol
IF Ncol < 3 THEN
  COLOR 10
  PRINT " That is not a valid size. Your array is too small!"
  PRINT " Program stopped."
  COLOR 7
  GOTO TheEnd
END IF
INPUT " Is this to be a continuation computation  N/Y (Default N) "; Cont$
Cont$ = UCASE$(Cont$)
IF Cont$ <> "Y" THEN Cont$ = "N"
IF Cont$ = "Y" THEN
  INPUT " Enter the name of the file containing the input potentials ", InPotFle$
  OPEN "I", #5, InPotFle$
END IF
INPUT " Enter the name of the file to contain the computed potentials ", OutPotfle$
IF OutPotfle$ = "" THEN OutPotfle$ = "Ptential.out"
OPEN "O", #3, OutPotfle$
INPUT " Enter the name of the file to contain the textual output ", TextOutFle$
IF TextOutFle$ = "" THEN TextOutFle$ = "Ptential.txt"
OPEN "O", #4, TextOutFle$
PRINT
PRINT " For the next entry the number of iterations should "
PRINT " exceed the largest dimension of the array"
INPUT " Enter the maximum number of iterations:  ", Nsmuth
'Probably should be at least 10 times largest dimension
INPUT " Do you want the input files printed  N/Y (Default N) "; PrintIt$
IF UCASE$(PrintIt$) = "Y" THEN PrintIt$ = "Y"
INPUT " Do you wish to see the initial source/sink array   Y/N (Default Y) "; ShowScreen$
IF UCASE$(ShowScreen$) <> "N" THEN ShowScreen$ = "Y"
ShowScreen$ = UCASE$(ShowScreen$)
INPUT " Do you wish to see drawings of the results   Y/N (Default Y) "; Draw$
IF UCASE$(Draw$) <> "N" THEN Draw$ = "Y"
choice:
IF Cont$ <> "Y" THEN
  PRINT
  PRINT " Chose an input type:"
  PRINT "     1) Uniform distribution of source and sink density over each region."
  PRINT "     2) Sources and sinks assigned to centroids of each region."
 'PRINT "     4) Sources and sinks assigned to a selected point in each region."
 'PRINT "     5) Sources and sinks assigned to several location in each region."
  INPUT " Make a selection  (Default is choice 1):   ", Swtch%
  PRINT
  IF Swtch% < 1 THEN Swtch% = 1
  IF Swtch% > 2 THEN
    COLOR 10
    PRINT " That is not a valid choice. try again!"
    BEEP
    COLOR 7
    GOTO choice
  END IF
END IF
IF Swtch% = 1 THEN
  Switch% = 0
ELSE
  Switch% = 2
END IF
IF Cont$ = "Y" THEN Switch% = 1
DIM SHARED Narea(Nplus), RegValu(Nplus), ID(Nrow, Ncol), Source(Nrow, Ncol), Z(Nrow, Ncol)
DIM Ry%(Nplus), Rx%(Nplus), ArToT(Nplus), Isymbl$(Ncol)
DIM Plus AS STRING * 1, Minus AS STRING * 1, Blank AS STRING * 1, Border AS STRING * 1
Plus$ = "+": Minus$ = "-": Blank$ = " ": Border$ = "*"
Now1$ = MID$(TIME$, 1, 5)
Titl$ = " POTENTIAL FIELD CALCULATED USING POISSON'S EQUATION"
PRINT #4, Titl$
PRINT #4, " This is file "; UCASE$(TextOutFle$)
PRINT #4, " Computed using Tobler's POTFLOW program."
PRINT #4, " The ID array came from "; UCASE$(IdFileNam$)
PRINT #4, " The data came from "; UCASE$(InValFle$)
IF Cont$ = "Y" THEN
  PRINT #4, " Initial values came from "; UCASE$(InPotFle$)
END IF
PRINT #4, " The array of potentials went to "; UCASE$(OutPotfle$)
PRINT " Reading ID array ";
FOR I = 1 TO Nrow
  PRINT ".";
  FOR J = 1 TO Ncol
    INPUT #2, ID(I, J)
    IF ID(I, J) = 0 THEN ID(I, J) = Nplus  'Up-shifts "outside" area number
  NEXT J
NEXT I
PRINT
PRINT " Reading Source/Sink values ";
FOR L = 1 TO Nregs
  PRINT ".";
  INPUT #1, RegValu(L)
  RegMax = Max!(RegMax, RegValu(L))
  RegMin = Min!(RegMin, RegValu(L))
  ArToT(L) = 0!: Narea(L) = 0: Rx%(L) = 0: Ry%(L) = 0
NEXT L
PRINT
PRINT #4, " Input values are: Min ="; RegMin; "Max ="; RegMax; "Range is"; RegMax - RegMin
PRINT #4, Nregs; "regions "; Nrow; "rows "; Ncol; "columns"
'NOW INCLUDE OUTSIDE-REGION AREAS
ArToT(Nplus) = 0!: Narea(Nplus) = 0: RegValu(Nplus) = 0!
Rx%(Nplus) = 0: Ry%(Nplus) = 0
Nrow1 = Nrow - 1
Ncol1 = Ncol - 1
Scale = 0!
'COMPUTE AREA BY REGION
FOR J = 1 TO Ncol
  FOR I = 1 TO Nrow
    L = ID(I, J)
    Source(I, J) = 0!
    Narea(L) = Narea(L) + 1
  NEXT I
NEXT J
'ASSIGN VALUES TO THE ENTIRE ARRAY. THERE ARE THREE CASES
'Case 0: CALCULATE DENSITIES AND DISTRIBUTE UNIFORMLY OVER EACH REGION.
'Case 1: READ IN A SOURCE ARRAY, PRECOMPUTED SOMEHOW.
'Case 2: ASSIGN THE VALUE TO THE CENTER OF GRAVITY FOR EACH REGION.
'Cases 3 & 4 not ready
'Case 3: ASSIGN THE VALUE TO A SPECIFIC LOCATION IN EACH REGION.
'Case 4: INPUT A VARIABLE NUMBER OF SOURCE/SINK VALUES,
'        THEN CALCULATE AND ASSIGN THESE VALUES AS IN CASE 3.
SELECT CASE Switch%
CASE 0
 'Case 0: CALCULATE DENSITIES AND DISTRIBUTE UNIFORMLY OVER THE REGION
  PRINT " Assigning values to lattice ";
  PRINT #4, " Constant density assigned to each region"
  PRINT #4,
  FOR L = 1 TO Nplus
    Scale = Scale + RegValu(L)
    ValuOrig = RegValu(L)
    RegValu(L) = RegValu(L) / Narea(L)
    IF L = Nplus THEN PRINT #4,
    PRINT #4, " Region # ";
    PRINT #4, USING Fmt1$; L;
    PRINT #4, "  Ave = ";
    PRINT #4, USING Fmt2$; RegValu(L);
    PRINT #4, "  Original =";
    PRINT #4, USING Fmt2$; ValuOrig;
    PRINT #4, "  Area =";
    PRINT #4, USING Fmt1$; Narea(L)
    IF L = Nplus THEN
      PRINT #4, " (Outside of domain of interest)"
    END IF

  NEXT L
  PRINT #4,
  PRINT #4, " Sum over all regions is"; Scale
  IF Scale <> 0 THEN
    PRINT #4, " In and outsums do not balance!"
    PRINT #4, " This sum should be zero."
  END IF
  FOR J = 1 TO Ncol
    PRINT ".";
    FOR I = 1 TO Nrow
      L = ID(I, J)
      Source(I, J) = RegValu(L)
    NEXT I
  NEXT J
  PRINT
  PRINT " Constant density assumed in each region."
CASE 1
 'Case 1: READ IN A SOURCE MATRIX
 'This could, for example, have been produced by a previous computation,
 'by pycnophylactic reallocation, or by any other method.
  PRINT
  PRINT " Getting initial values from a previous computation ";
  PRINT #4, " Getting initial values from a previous computation " 'For testing
  FOR I = 1 TO Nrow
    PRINT ".";
    J = 0
    DO WHILE J < Ncol
      J = J + 1
      INPUT #5, Source(I, J)
     'PRINT #4, I; J, Source(I, J)      'For testing
    LOOP
  NEXT I
  PRINT #4, " End of input of previous values"   'For testing
 'This is to display the initial input array
  PRINT
  INPUT " Do you wish a diagram of these initial values Y/N (Default Y)"; SeeOld$
  IF SeeOld$ = "" THEN SeeOld$ = "Y"
  SeeOld$ = UCASE$(SeeOld$)
  IF SeeOld$ <> "Y" THEN GOTO SkipOld
  OldTitl$ = Titl$
  Titl$ = " This is the initial data read as input  -  "
  CALL DrawSurface(Nrow, Ncol, Scrn%, Source(), Titl$, Nits%)
  Titl$ = OldTitl$
  PRINT " Press enter to continue";
  COLOR 0
  INPUT Z$
  COLOR 7
  CLS
SkipOld:
  PRINT
  PRINT " Assigning initial values";
  FOR L = 1 TO Nplus
    RegValu(L) = 0!
  NEXT L
  FOR J = 1 TO Ncol
    PRINT ".";
    FOR I = 1 TO Nrow
      L = ID(I, J)
      W = Source(I, J)
      RegValu(L) = RegValu(L) + W
    NEXT I
  NEXT J
  PRINT
  PRINT #4, " Prespecified initial densities read in from file "; UCASE$(InPotFle$)
  PRINT #4, " Checking input sum of prespecified initial input"
  Scale = 0
  FOR L = 1 TO Nplus
    IF L = Nplus THEN PRINT #4,
    Scale = Scale + RegValu(L)
    PRINT #4, " Region"; L; " Sum ="; RegValu(L); " Area ="; Narea(L)
  NEXT L
  PRINT #4, " Sum of initial input values:"; Scale
  PRINT #4, " Prespecified density values"
CASE 2
 'Case 2: ASSIGN VALUE TO CENTER OF GRAVITY FOR EACH REGION
  PRINT " Assigning values to centroids ";
  FOR L = I TO Nplus
    Scale = Scale + RegValu(L)
  NEXT L
  PRINT #4, " Sum of original values is"; Scale
  Scale = 0
  FOR J = 2 TO Ncol1
    PRINT ".";
    FOR I = 2 TO Nrow1
      Source(I, J) = 0!
      L = ID(I, J)
      Ry%(L) = Ry%(L) + I
      Rx%(L) = Rx%(L) + J
    NEXT I
  NEXT J
  PRINT
  PRINT #4,
  PRINT #4, " Point Sources/Sinks are used."
  PRINT #4, " Centers of gravity are calculated as follows"
  FOR K = 1 TO Nregs
    Rx%(K) = (Rx%(K) / Narea(K)) + .5
    Ry%(K) = (Ry%(K) / Narea(K)) + .5
    PRINT #4, " Region"; K; "   Row"; Ry%(K); " Column"; Rx%(K); " Value "; RegValu(K)
    Source(Ry%(K), Rx%(K)) = RegValu(K)
    Scale = Scale + RegValu(K)
  NEXT K
  PRINT #4,
  PRINT #4, " Sum of point values is"; Scale
CASE 3
'Don't use this! (It's too much trouble)
'Case 3: ASSIGN VALUE TO A SPECIFIC LOCATION IN THE REGION
  PRINT , " Specific locations specified for input"
  PRINT #4, " Specific locations specified for input"
'These could be city locations.
'COORDINATES MUST BE ROW/COLUMN NUMBERS!
  PRINT #4,
  PRINT #4, " Point Sources/Sinks are used."
  PRINT #4,
  FOR L = 1 TO Nregs
    Scale = Scale + RegValu(L)
    INPUT #1, Ry%(L), Rx%(L)
    PRINT #4, "Region"; L; "Row"; Ry%(L); "Column"; Rx%(L); "Value "; RegValu(L)
    Source((Ry%(L)), (Rx%(L))) = RegValu(L)
  NEXT L
  PRINT #4, " Sum of original values:"; Scale
CASE 4
'DON'T USE THIS CASE! NOT YET PROGRAMMED
END SELECT
'IN AND OUT QUANTIES SHOULD MATCH!
Check = 0!
FOR J = 1 TO Ncol
  FOR I = 1 TO Nrow
    Check = Check + Source(I, J)
    NEXT I
NEXT J
'PRINT #4, " Sum over all I,J = "; Check; "(difference from zero due to rounding.)"
'ELIMINATE ROUNDING ERROR; force check to zero.
Check = Check / (Nrow * Ncol)
Smax = 0!
FOR J = 1 TO Ncol
  FOR I = 1 TO Nrow
    Source(I, J) = Source(I, J) - Check
    Smax = Max!(Smax, ABS(Source(I, J)))
  NEXT I
NEXT J
'PRINT #4, " Recomputed sum over all I,J = "; Dif; "now zero ?"
PRINT #4, " Largest absolute density value is"; Smax
'FIRST APPROXIMATION. Assume Poisson solution equals initial
'Source/Sink, or an approximation from a previous run.
FOR J = 1 TO Ncol
  FOR I = 1 TO Nrow
    Z(I, J) = Source(I, J)
  NEXT I
NEXT J
'OUTPUT INITIAL CONDITIONS
IF PrintIt$ <> "Y" THEN GOTO NoPrint
PRINT #4,
PRINT #4, " Iterations started using the following values"
IF Cont$ = "Y" THEN
  PRINT #4, " from prior interpolation in:"; UCASE$(InPotFle$)
ELSE
  PRINT #4, " from data in: "; UCASE$(InValFle$); " divided by area"
  FOR I = 1 TO Nregs
    PRINT #4, I, RegValu(I)
  NEXT I
END IF
PRINT #4,
CALL NicePrint(Nrow, Ncol, 4, Z())
NoPrint:
'DISPLAY SOURCES/SINKS ON SCREEN AND/OR PRINTER
IF ShowScreen$ = "N" THEN GOTO DisplayPrint
'On screen
Scrn% = 9
Xmin = 1: Xmax = Ncol: Ymin = Ncol: Ymax = 1
PRINT " Press 'Enter' when ready to see the initial source/sink array."
DO WHILE INKEY$ = "": LOOP
CALL Plotsize(Scrn%, Xmin, Xmax, Ymin, Ymax)
CALL Pm(Nplus, Nrow, Ncol, Xmin, Xmax, Ymin, Ymax)
DisplayPrint:
'On printer
IF Ncol > 75 THEN
  PRINT #4, " The array is too wide to print"
  GOTO TooWide
END IF
PRINT #4,
PRINT #4, " Initial Source/Sink array"
FOR I = 1 TO Nrow
  FOR J = 1 TO Ncol
    Zold = Source(I, J)
    Isymbl$(J) = Blank$
   'IF Id(I, J) = Nplus THEN Isymbl$(J) = Blank$
    IF Zold > 0! THEN Isymbl$(J) = Plus$
    IF Zold < 0! THEN Isymbl$(J) = Minus$
    IF (I = 1) OR (I = Nrow) THEN Isymbl$(J) = Border$
    IF (J = 1) OR (J = Ncol) THEN Isymbl$(J) = Border$
  NEXT J
  FOR K = 1 TO Ncol
    PRINT #4, Isymbl$(K);
  NEXT K
  PRINT #4,
NEXT I
TooWide:
IF Nsmuth > 0 THEN
  CALL Poisson(Nrow, Ncol, Nsmuth, Nplus, Nits%)
END IF
PRINT
PRINT " Writing out results, please wait a bit more."
PRINT #4, " The array of potentials went to "; UCASE$(OutPotfle$)
'Check Poisson solution and total potentials by region
Check = 0!: XminI = 1E+30: XmaxI = -XminI
FOR J = 1 TO Ncol
  FOR I = 1 TO Nrow
    W = Z(I, J)
    L = ID(I, J)
    Check = Check + W
    ArToT(L) = ArToT(L) + W
    XminI = Min!(XminI, W)
    XmaxI = Max!(XmaxI, W)
  NEXT I
NEXT J
PRINT #4, " Sum over all I,J was = "; Check
PRINT #4,
PRINT #4, " Potential totals by region"
PRINT #4, " Recall that there is an arbitrary constant of integration"
PRINT #4, " (which can be set to zero)"
FOR L = 1 TO Nplus
  IF L = Nplus THEN PRINT #4,
  PRINT #4, " Region"; L; " Total value = "; ArToT(L)
  IF L = Nplus THEN
    PRINT #4, " (Outside of domain of interest)"
  END IF
NEXT L
Range = XmaxI - XminI
PRINT #4,
PRINT #4, " Lows and highs of the potential are:"
PRINT #4, " Min = "; XminI; " Max = "; XmaxI; " Range = "; Range
PRINT #4, " Recall that a constant of integration is involved"
PRINT #4,
'STORE POTENTIAL FIELD
CALL NicePrint(Nrow, Ncol, 3, Z())
PRINT
'IF Nsmuth > 50 THEN   'This is so you can leave for a while
'  BEEP: BEEP: BEEP
'END IF
IF UCASE$(Draw$) = "N" THEN GOTO SkipDraw
CALL DrawSurface(Nrow, Ncol, Scrn%, Z(), Titl$, Nits%)
SkipDraw:
Now$ = MID$(TIME$, 1, 5)
PRINT #3,
PRINT #3, Titl$
PRINT #3, Nrow; "rows by"; Ncol; "columns"
PRINT #3, " This is file "; UCASE$(OutPotfle$)
PRINT #3, " The ID array came from "; UCASE$(IdFileNam$)
PRINT #3, " The data came from "; UCASE$(InValFle$)
IF Cont$ = "Y" THEN
  PRINT #3, " Initial values came from "; UCASE$(InPotFle$)
END IF
PRINT #3, " Results were also sent to "; UCASE$(TextOutFle$)
PRINT #3, Nsmuth; "iterations requested."; Nits%; "actually used."
PRINT #3, " Min = "; XminI; " Max = "; XmaxI; " Range = "; Range
PRINT #3, " Finished at "; Now$; " on "; DATE$
PRINT #3,
PRINT #3, " Computed using Tobler's POTFLOW program."
PRINT #3, " Program version of 6/11/98"
PRINT #4, " Started at  "; Now1$; " on "; DATE$
PRINT #4, " Finished at "; Now$; " on "; DATE$
PRINT #4,
PRINT #4, " Computed using Tobler's POTFLOW program."
PRINT #4, " Program version of 6/11/98"
PRINT
CLOSE
COLOR 10
PRINT "       Thank Waldo Tobler For this Program"
COLOR 7
DO WHILE INKEY$ = "": LOOP
TheEnd:
PRINT
PRINT : PRINT "       D O N E"
END

SUB DrawGrid (Rows%, Cols%, Scrn%, Xmax, Xmin, Ymax, Ymin)
'Draw the irregular grid
COLOR 8
Root% = INT(SQR(Rows% * Cols%))
IF Root% >= 51 THEN
  Delta% = 10
  GOTO GotGrid
END IF
FOR K = 10 TO 51 STEP 10
  IF Root% < K THEN
    Delta% = K / 10
    GOTO GotGrid
  END IF
NEXT K
GotGrid:
'Draw vertical grid
FOR I = 1 TO Cols% STEP Delta%
  PSET (I, Ymin + Delta% / 2)
  LINE -(I, Ymin - Delta% / 2), , , &H1111
  IF I = 1 OR I = Cols% THEN
    PSET (I, Ymin)
    LINE -(I, Ymax)
  ELSE
    PSET (I, Ymin)
    LINE -(I, Ymax)
  END IF
  PSET (I, Ymax)
  LINE -(I, Ymax - Delta% / 2), , , &H1111
NEXT I
'Draw horizontal grid
FOR I = Rows% TO 1 STEP -Delta%
  PSET (Xmin + Delta% / 2, I)
  LINE -(Xmin, I), , , &H1111
  IF I = 1 OR I = Rows% THEN
    PSET (Xmin, I)
    LINE -(Xmax, I)
  ELSE
    PSET (Xmin, I)
    LINE -(Xmax, I)
  END IF
  PSET (Xmax, I)
  LINE -(Xmax - Delta% / 2, I), , , &H1111
NEXT I
PRINT " Grid interval is"; Delta%
EXIT SUB
END SUB

SUB DrawSurface (Rows%, Cols%, Scrn%, Z(), Titl$, Nits%)
DIM Zw(Rows%, Cols%)
Scrn% = 9
COLOR 7
Zmax = -1E-12
Zmin = 1E+12
INPUT " Do you wish to see the contour map Y/N (Default Y) "; Contr$
IF UCASE$(Contr$) <> "N" THEN Contr$ = "Y"
INPUT " Do you wish to see an isometric diagram Y/N (Default Y) "; Diagr$
IF UCASE$(Diagr$) <> "N" THEN Diagr$ = "Y"
IF UCASE$(Contr$) = "N" AND UCASE$(Diagr$) = "N" THEN EXIT SUB
PRINT " Computing some parameters ";
FOR J = 1 TO Cols%
  PRINT ".";
  FOR I = 1 TO Rows%
    W = Z(I, J)
    Zmax = Max!(Zmax, W)
    Zmin = Min!(Zmin, W)
    Zw(Rows% - I + 1, J) = W
  NEXT I
NEXT J
IF Zmax = Zmin THEN
  COLOR 10
  PRINT
  PRINT " Zmax=Zmin. Somethings wrong"
  PRINT #4, " Zmax=Zmin. Somethings wrong"
  FOR I = 1 TO Rows%
    FOR J = 1 TO Cols%
      PRINT #4, I; J, Z(I, J)
    NEXT J
  NEXT I
  CLOSE
  STOP
END IF
FOR J = 1 TO Cols%
  FOR I = 1 TO Rows%
    Z(I, J) = Zw(I, J)
  NEXT I
NEXT J
PRINT
ERASE Zw
Xmin = 1
Xmax = Cols%
Ymin = 1
Ymax = Rows%
Dz = Zmax - Zmin
Dx = Xmax - Xmin
Dy = Ymax - Ymin
IF Rows% * Cols% > 900 THEN
  PRINT " Still computing. Please wait some more "
END IF
IF UCASE$(Diagr$) = "N" THEN GOTO SkipThis
CALL Plane(Rows%, Cols%, Z(), A, B, C)
' PRINT " The least squares plane is Z = "; A;
' IF B < 0 THEN
'   PRINT " "; B; "X ";
' ELSE
'   PRINT "+"; B; "X ";
' END IF
' IF C < 0 THEN
'   PRINT " "; C; "Y."
' ELSE
'   PRINT "+"; C; "Y."
' END IF
' PRINT " (This is used to decide on the isometric view.)"
IF C < 0 THEN
  PRINT " Scanning the data suggests that flipping the isometric diagram"
  INPUT " gives the best view. Do you wish to override this  Y/N (Default Y)"; Flip$
  IF Flip$ = "" THEN Flip$ = "Y"
  IF UCASE$(Flip$) = "Y" THEN
    C = -C
    PRINT " Isometric diagram will not be flipped."
  ELSE
    PRINT " Isometric diagram will be flipped N-S"
  END IF
END IF
SkipThis:
IF UCASE$(Contr$) = "N" THEN GOTO SkipContour
Dz = Dz / 10
IF Dz = 0 THEN GOTO SkipContour
Dzz = Dz
PRINT " The contour interval on the map will be "; Dz
NewContur:
INPUT " Do you wish to change the contour interval  Y/N (Default Y)"; Change$
IF Change$ = "" THEN Change$ = "Y"
IF UCASE$(Change$) = "Y" THEN
  INPUT " Enter a new value for the contour interval ", Dz
  IF Dz = 0 THEN
    COLOR 10
    PRINT " Zero is not a valid entry. Try again"
    PRINT " Suggested contour interval was "; Dzz
    COLOR 7
    GOTO NewContur
  ELSEIF Dz < 0 THEN
    COLOR 10
    PRINT " Negative contour intervals are not allowed. Try again."
    PRINT " Suggested contour interval was "; Dzz
    COLOR 7
    GOTO NewContur
  END IF
END IF
PRINT " Press enter to see the contour map ";
DO WHILE INKEY$ = "": LOOP
CLS
CALL Plotsize(Scrn%, Xmin, Xmax, Ymin, Ymax)
'Do contouring
COLOR 8
PRINT Titl$;
PRINT " WITH"; Nits%; "ITERATIONS"
PRINT " The contour interval is "; Dz; " The array is"; Rows%; "by"; Cols%;
CALL DrawGrid(Rows%, Cols%, Scrn%, Xmin, Xmax, Ymin, Ymax)
CALL SetUpTri(Rows%, Cols%, Scrn%, Z(), Dz)
COLOR 8
'Draw bounding rectangle
PSET (Xmin, Ymin)
LINE -(Xmax, Ymin)
LINE -(Xmax, Ymax)
LINE -(Xmin, Ymax)
LINE -(Xmin, Ymin)
SkipContour:
IF Diagr$ = "N" THEN
  PRINT " Press enter to end."
  DO WHILE INKEY$ = "": LOOP
  GOTO SkipDiagrm
END IF
IF UCASE$(Contr$) = "N" THEN
  COLOR 8
  PRINT " Press enter when ready for the isometric diagram.";
  DO WHILE INKEY$ = "": LOOP
  CLS
  CALL Plotsize(Scrn%, Xmin, Xmax, Ymin, Ymax)
ELSE
  PRINT " Press enter when ready for the isometric diagram.";
  DO WHILE INKEY$ = "": LOOP
  CLS
END IF
'Do isometric plot
COLOR 3
CALL IsoPlot(Rows%, Cols%, Scrn%, Nits%, Z(), Xmin, Xmax, Ymin, Ymax, Zmin, Zmax, C, Titl$)
SkipDiagrm:
CLS
EXIT SUB
END SUB

DEFSNG I-N
'Isometric diagram plotting subprogram.
'Conversion by W. Tobler, Dec 1993, to a BASIC subroutine from a FORTRAN
'translation of a 1965 University of Michigan MAD program by W. Tobler.
SUB IsoPlot (Rows%, Cols%, Scrn%, Nits%, Z(), Xmin, Xmax, Ymin, Ymax, Zmin, Zmax, C, Titl$)
DEFSNG A-H, O-Z: DEFINT I-N
'ALF = Isometric angle in degrees (default = 30.)
ALF = 30!
Rad = .0174532925#
ALF = ALF * Rad
Salf = SIN(ALF)
Calf = COS(ALF)
IF C > 0 THEN
  R% = 1
  R1% = Rows%
  Dr% = -1
ELSE
 'If C < 0 then the data slope away from the viewer. Flip view.
 'Flip top to bottom for better view.
  R% = Rows%
  R1% = 1
  Dr% = 1
END IF
'PRINT R%; R1%, Dr%
Rw = Rows%: Cl = Cols%
grid% = FIX(Max!(Rw, Cl)) + 1
DIM Xl(grid%), Yl(grid%)
'Foreshorten
Salf = .75 * Salf
Calf = .75 * Calf
Front = Xmax - Xmin
Side = (Ymax - Ymin) * Calf
Wide = Front + Side
'Get amount to translate to center
Dx = Side / 2
'VERTICAL SCALE
'Scaling data height
Zrange = Zmax - Zmin
Hgt = (Ymax - Ymin) * Salf
Dz = Hgt / Zrange
'The next 7 lines enlarge the drawing a bit.
Xmid = (Xmin + Wide) / 2
Ymid = (Ymin + 2 * Hgt) / 2
Xn = Xmid - Wide / 2 - 2 * Dx
Xx = Xmid + Wide / 2 + Dx
Yn = Ymid - Hgt
Yx = Ymid + Hgt + Dx / 2
WINDOW (Xn, Yn)-(Xx, Yx)
'Scaling height to be a fraction of side height
Dz = .6 * Dz
Rescale:
'BEGIN PLOTTING
REDIM Xl(grid% + 3), Yl(grid% + 3)
COLOR 14
'GOTO SkipRowProf           'To test program; deactivate when ok
'PRINT "Row profiles"       'To test program; deactivate when ok
'DRAW PROFILES ACROSS THE ROWS
FOR I = R1% TO R% STEP Dr%
  K = R% - I + R1%
  IF C < 0 THEN
    Dy = I - Ymin
  ELSE
    Dy = K - Ymin
  END IF
  Cy = Dy * Calf
  Yc = Dy * Salf + Ymin
  FOR J = 1 TO Cols%
    Yl(J) = Yc + Dz * (Z(K, J) - Zmin)
    Xl(J) = Cy + J
    IF J = 1 THEN
      PSET (Xl(1) - Dx, Yl(1))
    ELSE
      LINE -(Xl(J) - Dx, Yl(J))
    END IF
  NEXT J
  COLOR 14
NEXT I
SkipRowProf:
'GOTO SkipColProf           'To test program; deactivate when ok
'PRINT "Column profiles"    'To test program; deactivate when ok
'DRAW PROFILES UP THE COLUMNS
IF Rows% > 40 AND Cols% > 40 THEN
  ColProf% = Cols% - 1
ELSE
  ColProf% = 1
END IF
'Screen resolution is too poor to show both dense row & column profiles
FOR J = Cols% TO 1 STEP -ColProf%
  Xc = J
 'PRINT R%, R1%, Dr%            'To test program; deactivate when ok
  FOR I = R1% TO R% STEP Dr%
   'PRINT "I,K"; I; K           'To test program; deactivate when ok
    K = R% - I + R1%
    IF C < 0 THEN
      Dy = I - Ymin
    ELSE
      Dy = K - Ymin
    END IF
    Yl(I) = Dy * Salf + Ymin + Dz * (Z(K, J) - Zmin)
    Xl(I) = Xc + Calf * Dy
    IF I = R1% THEN
      PSET (Xl(R1%) - Dx, Yl(R1%))
    ELSE
      LINE -(Xl(I) - Dx, Yl(I))
    END IF
  NEXT I
NEXT J
SkipColProf:
'GOTO skipbot               'To test program; deactivate when ok
'PUT BOTTOM ON THE DIAGRAM
REDIM Xl(6), Yl(6)
COLOR 8
Yy = Rows%
Xl(1) = Calf * (Yy - Ymin) + Xmax - Dx
Yl(1) = Salf * (Yy - Ymin) + Dz * (Z(R1%, Cols%) - Zmin) + Ymin
Xl(2) = Calf * (Yy - Ymin) + Xmax - Dx
Yl(2) = Salf * (Yy - Ymin) + Ymin
Xl(3) = Xmax - Dx
Yl(3) = Ymin
Xl(4) = Xmin - Dx
Yl(4) = Ymin
Xl(5) = Xmin - Dx
Yl(5) = Dz * (Z(R%, 1) - Zmin) + Ymin
Xl(6) = Xmax - Dx
Yl(6) = Dz * (Z(R%, Cols%) - Zmin) + Ymin
'PRINT #4, " Base Coordinates are:"   'To test program; deactivate when ok
'FOR Zz = 1 TO 6                      'To test program; deactivate when ok
  'PRINT #4, Zz; Xl(Zz), Yl(Zz)       'To test program; deactivate when ok
'NEXT Zz                              'To test program; deactivate when ok
PSET (Xl(1), Yl(1))
LINE -(Xl(2), Yl(2))
LINE -(Xl(3), Yl(3))
LINE -(Xl(4), Yl(4))
LINE -(Xl(5), Yl(5))
PSET (Xl(3), Yl(3))
LINE -(Xl(6), Yl(6))
skipbot:
COLOR 8
IF C > 0 THEN
  PRINT Titl$;
  PRINT " WITH"; Nits%; "ITERATIONS"
  PRINT " Isometric diagram. Hidden lines not deleted. "
  INPUT " Press + or - to rescale vertical exaggeration, press enter to end program  ", X$
  IF X$ = "+" THEN
    Dz = Dz * 1.25
    CLS
    GOTO Rescale
  ELSEIF X$ = "-" THEN
    Dz = .5 * Dz
    CLS
    GOTO Rescale
  ELSE
    GOTO Fini
  END IF
ELSE
 'Flipped top to bottom for better view.
  PRINT Titl$;
  PRINT " WITH"; Nits%; "ITERATIONS"
  PRINT " Isometric diagram, with array flipped for a better view."
  INPUT " Hidden lines not deleted. Press +/- to rescale, enter to exit program  ", X$
  IF X$ = "+" THEN
    Dz = Dz * 1.25
    CLS
    GOTO Rescale
  ELSEIF X$ = "-" THEN
    Dz = Dz * .5
    CLS
    GOTO Rescale
  ELSE
    GOTO Fini
  END IF
END IF
Fini:
EXIT SUB
END SUB

FUNCTION Max! (A, B)
Max! = A
IF B > A THEN Max! = B
EXIT FUNCTION
END FUNCTION

FUNCTION Min! (A, B)
Min! = A
IF B < A THEN Min! = B
EXIT FUNCTION
END FUNCTION

SUB NicePrint (Nrows, Ncols, Unit%, Z())
Five = 5
Fmt$ = "##.######^^^^"
FOR I = 1 TO Nrows
  KountCol = 0
  FOR J = 1 TO Ncols
    IF J < Ncols THEN
      KountCol = KountCol + 1
      IF KountCol < Five THEN
        PRINT #Unit%, USING Fmt$; Z(I, J);
        PRINT #Unit%, " ";
      ELSE
        PRINT #Unit%, USING Fmt$; Z(I, J)
        KountCol = 0
      END IF
    ELSE
      PRINT #Unit%, USING Fmt$; Z(I, J)
    END IF
  NEXT J
NEXT I
EXIT SUB
END SUB

SUB Order (X1, X2, X3, Y1, Y2, Y3, F1, F2, F3)
DIM X(3), Y(3), F(3)
X(1) = X1
X(2) = X2
X(3) = X3
Y(1) = Y1
Y(2) = Y2
Y(3) = Y3
F(1) = F1
F(2) = F2
F(3) = F3
Fmax = Max!(F1, F2)
Fmax = Max!(Fmax, F3)
Fmin = Min!(F1, F2)
Fmin = Min!(Fmin, F3)
FOR K = 1 TO 3
  IF F(K) = Fmax THEN K3 = K
  IF F(K) = Fmin THEN K1 = K
NEXT K
FOR K = 1 TO 3
  IF K <> K1 AND K <> K3 THEN K2 = K
NEXT K
F1 = F(K1)
F2 = F(K2)
F3 = F(K3)
X1 = X(K1)
X2 = X(K2)
X3 = X(K3)
Y1 = Y(K1)
Y2 = Y(K2)
Y3 = Y(K3)
EXIT SUB
END SUB

DEFSNG I-N
'Least Squares Plane
'Used to decide isometric viewing position,
'on the basis of the direction of dZ/dY.
SUB Plane (Rows%, Cols%, Z(), A, B, C)
DEFINT I-N
PRINT " Computing best viewing direction ";
N = Rows% * Cols%
FOR I = Rows% TO 1 STEP -1
  PRINT ".";
  FOR J = 1 TO Cols%
    Ya = I
    Sy = Sy + Ya
    Syy = Syy + Ya * Ya
    Xa = J
    Sx = Sx + Xa
    Sxx = Sxx + Xa * Xa
    Sxy = Sxy + Xa * Ya
    Za = Z(I, J)
    Sz = Sz + Za
    Sxz = Sxz + Xa * Za
    Syz = Syz + Ya * Za
  NEXT J
NEXT I
PRINT
Det = N * (Sxx * Syy - Sxy * Sxy) + Sx * (Sy * Sxy - Sx * Syy) + Sy * (Sx * Sxy - Sy * Sxx)
'PRINT "Determinant is "; Det
IF Det = 0 THEN
  BEEP
  PRINT " Zero determinant"
  C = 0
  EXIT SUB
END IF
A = Sz * (Sxx * Syy - Sxy * Sxy) - Sxz * (Sx * Syy - Sy * Sxy) + Syz * (Sx * Sxy - Sy * Sxx)
A = A / Det
B = Sz * (Sy * Sxy - Sx * Syy) + Sxz * (N * Syy - Sy * Sy) + Syz * (Sx * Sy - N * Sxy)
B = B / Det
C = Sz * (Sx * Sxy - Sy * Sxx) - Sxz * (N * Sxy - Sy * Sx) + Syz * (N * Sxx - Sx * Sx)
C = C / Det
EXIT SUB
END SUB

SUB Plotsize (Scrn%, Xmin, Xmax, Ymin, Ymax)
DEFINT I-N
Scrn% = 9
'Size the data for a drawing
SCREEN Scrn%
Dx = Xmax - Xmin
Dy = Ymax - Ymin
Range = Max!(Dx, Dy)
Xmid = Xmin + Dx / 2
Ymid = Ymin + Dy / 2
Xn = Xmid - Range
Xx = Xmid + Range
Yn = Ymid - .8 * Range
Yx = Ymid + .8 * Range
WINDOW (Xn, Yn)-(Xx, Yx)
EXIT SUB
END SUB

DEFSNG I-N
SUB Pm (Nplus%, Nr%, Nc%, Xmin, Xmax, Ymin, Ymax)
'Pm is an abbreiviation for "Plus or Minus"
DEFINT I-K, N
SHARED Narea(), RegValu(), ID(), Source()
CLS
'                   Program to Draw + or - Regions on Screen
'                   ----------------------------------------
'                               By Waldo Tobler
COLOR 14
PRINT "  Yellow = Source region  ";
COLOR 12
PRINT "  Red = Sink region  ";
COLOR 9
PRINT "  Blue = outside of domain"
Dx = Xmax - Xmin
Dy = Ymax - Ymin
Range = Dy
IF Dx > Dy THEN Range = Dx
Xmax = Xmax + .1 * Range
Ymin = Ymin - .1 * Range
Xmin = Xmax - 1.2 * Range
Ymax = Ymin + 1.2 * Range
'Get ready to plot
Idex = 0: Jdex = 0
FOR I = 1 TO Nr
  Y = Nr - I
  IF I = 1 OR I = Nr THEN Idex = 1
  FOR J = 1 TO Nc
    X = J
    IF J = 1 OR J = Nc THEN Jdex = 1
    IF Idex + Jdex > 0 THEN
      COLOR 9
      GOTO Plotit
    END IF
    W = Source(I, J)
    COLOR 0
    IF W < 0! THEN
    'Negative values
      COLOR 12
    ELSEIF W > 0 THEN
    'Positive values
      COLOR 14
    END IF
  'Zero value
    IF ID(I, J) = Nplus THEN COLOR 0
Plotit:
   'PSET (X, Y)
    CIRCLE (X, Y), .125
    Jdex = 0
  NEXT J
  Idex = 0
NEXT I
COLOR 8
PRINT "  Press a key when ready to continue"
DO WHILE INKEY$ = "": LOOP
CLS
EXIT SUB
END SUB

DEFINT L-M
SUB Poisson (Nrow, Ncol, Nsmuth, Nplus, K)
'ROUTINE TO SOLVE POISSON EQUATION
'BOUNDARY CONDITION; F'(X,Y)=0 -> a flat edge.
SHARED Narea(), RegValu(), ID(), Source(), Z()
COLOR 7
PRINT #4,
PRINT #4, " Poisson solver used."
PRINT " POISSON SOLVER CALLED"
PRINT " Iterating, Please wait ";
Eps = 1  ' % stopping criteria
Nrow1 = Nrow - 1
Ncol1 = Ncol - 1
'SET UP CONSTANT OF INTEGRATION TO STABILIZE BOUNDARIES
Imidl = Nrow / 2
Jmidl = Ncol / 2
DoMore:
Ix = ID(Imidl, Jmidl)
IF Ix = Nplus THEN Imidl = Imidl + 1
IF Ix = Nplus THEN Jmidl = Jmidl + 1
IF Ix = Nplus THEN GOTO DoMore
ValAtMid = Source(Imidl, Jmidl)
PRINT #4, " Mid point at: Row="; Imidl; "Col="; Jmidl; "Value= "; ValAtMid
'IMPROVE VALUE BY SMOOTHING
KK = 0
FOR K = 1 TO Nsmuth
  PRINT ".";
  Dif = 0!
  Kount = 0
 'Loop thru entire array
  FOR J = 2 TO Ncol1
    Jminus = J - 1
    Jplus1 = J + 1
    FOR I = 2 TO Nrow1
      Iminus = I - 1
      Iplus1 = I + 1
      S = 0!
     'SET FLAGS FOR BOUNDARY CASE CONDITIONALS
      Keast = 1: Knorth = 1: Kwest = 1: Ksouth = 1
     'GET NEIGHBOR CASES
     'These are neighbors which are outside of the domain,
     'not the edges of the array, although this is also possible.
     'Eastern neighbor
      IF ID(I, Jplus1) = Nplus THEN Keast = 0
     'Northern neighbor
      IF ID(Iminus, J) = Nplus THEN Knorth = 0
     'Western neighbor
      IF ID(I, Jminus) = Nplus THEN Kwest = 0
     'Southern neighbor
      IF ID(Iplus1, J) = Nplus THEN Ksouth = 0
      Ksum = Keast + Knorth + Kwest + Ksouth
     'SEPARATE INTERIOR FROM EXTERIOR
      IF ID(I, J) = Nplus THEN GOTO Exterior
     'SMOOTH INTERIOR NODES
     'Influence from valid interior neighbors only
      SK = Ksum
      Temp = Z(I, J)
      IF Ksum = 0 THEN GOTO NotEdge
     'Check for edge of region
      IF Keast > 0 THEN S = S + Z(I, Jplus1)
      IF Knorth > 0 THEN S = S + Z(Iminus, J)
      IF Kwest > 0 THEN S = S + Z(I, Jminus)
      IF Ksouth > 0 THEN S = S + Z(Iplus1, J)
NotEdge:
      T = S / SK + Source(I, J)
     'CONSTANT OF INTEGRATION
      IF (I = Imidl) AND (J = Jmidl) THEN SUBTR = T - ValAtMid
      GOTO Skip
     'interior completed
Exterior:
     'EXTERIOR NODES; Set up boundary condition
     'There are two kinds of exterior nodes:
     'Those interior to the array but not regions of interest
     'Those on the edges of the array.
     'For the first type do the following:
      IF Ksum = 0 THEN GOTO NotBndy
     'For the second type do this:
      IF Keast = 0 THEN GOTO NotEast
      S = S + Z(I, Jplus1)      'This is for east edge
NotEast:
      IF Knorth = 0 THEN GOTO NotNorth
      S = S + Z(Iminus, J)      'This is for north edge
NotNorth:
      IF Kwest = 0 THEN GOTO NotWest
      S = S + Z(I, Jminus)      'This is for west edge
NotWest:
      IF Ksouth = 0 THEN GOTO NotSouth
      S = S + Z(Iplus1, J)      'This is for south edge
NotSouth:
      T = S / Ksum
      GOTO ApplyChange
NotBndy:
      T = .25 * (Z(I, Jminus) + Z(I, Jplus1) + Z(Iminus, J) + Z(Iplus1, J))
      GOTO ApplyChange
Skip:
      Kount = Kount + 1
     'Accumulate squared diviations
      Dif = Dif + ((Temp - T) ^ 2)
ApplyChange:
      Z(I, J) = T
    NEXT I
  NEXT J
 'Main iteration completed
 'Apply normalization to all interior cells
  FOR J = 2 TO Ncol1
    FOR I = 2 TO Nrow1
      Z(I, J) = Z(I, J) - SUBTR
    NEXT I

   'Set border cell value equal to first adjacent interior cell
   'Border cases; top and bottom
    Z(1, J) = Z(2, J)
    Z(Nrow, J) = Z(Nrow1, J)
  NEXT J
  FOR I = 2 TO Nrow1
   'Border cases; left and right
    Z(I, 1) = Z(I, 2)
    Z(I, Ncol) = Z(I, Ncol1)
  NEXT I
 'Corner cases
  Z(1, 1) = .5 * (Z(1, 2) + Z(2, 1))
  Z(1, Ncol) = .5 * (Z(1, Ncol1) + Z(2, Ncol))
  Z(Nrow, 1) = .5 * (Z(Nrow1, 1) + Z(Nrow, 2))
  Z(Nrow, Ncol) = .5 * (Z(Nrow, Ncol1) + Z(Nrow1, Ncol))
 'All values adjusted now

 'CALCULATE AND PRINT R.M.S.R.
 'Normalize after 1st iteration, only
  IF K <> 1 THEN GOTO NotFirstTime
  Dif = SQR(Dif / Kount)
  PRINT #4, " Computed Roughness Measure (Root Mean Square Roughness):"
  PRINT #4, " Initial R.M.S.R. = "; Dif; " Constrained to equal 100%"
  Error1 = Dif
  Dif = 100!
  LastDif = Dif
  GOTO OtherTime
NotFirstTime:
  Dif = (SQR((Dif / Kount) / Error1)) * 100
OtherTime:
  IF K > 15 THEN GOTO BigTime
  PRINT #4, " Iteration="; K; "      R.M.S.R.= "; Dif
  GOTO Test
BigTime:
  KK = KK + 1
  IF KK <> 10 THEN GOTO Test
  PRINT #4, " Iteration="; K; "      R.M.S.R. ="; Dif
  KK = 0
Test:
 'Stopping criteria
  IF Dif < Eps THEN GOTO Enough
  IF K = Nsmuth THEN GOTO Done
NEXT K
'End of smoothing
Enough:
PRINT #4, Dif; " R.M.S.R. Is less than 1% at"; K; " iterations"
Done:
PRINT #4, K; "iterations finished with a discrepancy of"; Dif; "%"
PRINT #4,
EXIT SUB
END SUB

'Contouring subroutines by Sam Outcalt
'Converted to QuickBasic by Waldo Tobler
SUB SetUpTri (Rows%, Cols%, Scrn%, Z(), H)
DEFINT I-N
Scrn% = 9
COLOR 14
FOR I = 2 TO Rows%
  K = Rows% - I + 1
  YSW = K
  YSE = YSW
  YNW = K + 1
  YNE = YNW
  FOR J = 2 TO Cols%
    XSW = J - 1
    XNW = XSW
    XSE = J
    XNE = XSE
    ZSW = Z(K, J - 1) + 100!
    ZSE = Z(K, J) + 100!
    ZNW = Z(K + 1, J - 1) + 100!
    ZNE = Z(K + 1, J) + 100!
    CALL TriCon(XSW, XNW, XNE, YSW, YNW, YNE, ZSW, ZNW, ZNE, H)
    CALL TriCon(XSW, XSE, XNE, YSW, YSE, YNE, ZSW, ZSE, ZNE, H)
  NEXT J
NEXT I
EXIT SUB
END SUB

SUB TriCon (X1, X2, X3, Y1, Y2, Y3, F1, F2, F3, H)
DIM X(2), Y(2)
Xa = X1
Xb = X2
Xc = X3
Ya = Y1
Yb = Y2
Yc = Y3
Fa = F1
Fb = F2
Fc = F3
CALL Order(Xa, Xb, Xc, Ya, Yb, Yc, Fa, Fb, Fc)
M = FIX(Fc / H)
N = FIX(Fa / H) + 1
Icon& = H * 5
K = M - N + 1
IF K <= 0 THEN GOTO AllDone
FOR J = N TO M
  Fi = CSNG(J) * H
  Beck = Fi / Icon&
  Deck = Beck - FIX(Beck)
  IF Fa = Fc THEN GOTO GetNext
  X(1) = Xint(Xa, Xc, Fa, Fc, Fi)
  Y(1) = Xint(Ya, Yc, Fa, Fc, Fi)
  IF Fi > Fb THEN
    X(2) = Xint(Xb, Xc, Fb, Fc, Fi)
    Y(2) = Xint(Yb, Yc, Fb, Fc, Fi)
  ELSEIF Fi <= Fb THEN
    X(2) = Xint(Xa, Xb, Fa, Fb, Fi)
    Y(2) = Xint(Ya, Yb, Fa, Fb, Fi)
  END IF
  PSET (X(1), Y(1))
  LINE -(X(2), Y(2))
  IF Deck > 0! THEN GOTO GetNext
  PSET (X(1), Y(1))
  LINE -(X(2), Y(2))
GetNext:
NEXT J
AllDone:
EXIT SUB
END SUB

FUNCTION Xint (X1, X2, F1, F2, Fi)
IF F1 = F2 THEN
  Xint = X1
''  XRXINT = X1
  GOTO GotIt
END IF
Xint = X1 + ((Fi - F1) / (F2 - F1)) * (X2 - X1)
''XRXINT = X1 + ((Fi - F1) / (F2 - F1)) * (X2 - X1)
GotIt:
EXIT FUNCTION
END FUNCTION

